         MACRO
&NM      IOWA  &TYPE
         GBLA  &BUFRMAX            Buffer size--defined in SYSDEFN
.*
&CSECT   SETC  '&SYSECT'           get csect name
         TITLE 'IOWA -- WYLBUR''S I/O WORK AREA'
         AIF   ('&TYPE' EQ '').NOSECT
         AIF   ('&TYPE'(1,1) EQ 'C').CSECT
         AIF   ('&TYPE'(1,1) EQ 'D').DSECT
         MNOTE 4,'&TYPE INVALID - IGNORED'
         AGO   .NOSECT
.DSECT   ANOP
&NM      DSECT
         AGO   .NOSECT
.CSECT   ANOP
&NM      CSECT
.NOSECT  ANOP
*PUSH,GEN
***************** WYLBUR's I/O work area *******************
**                                                        **
**    work area used by DISK                              **
**                                                        **
** The DISK work area contains all variable information   **
** to permit I/O operations to operate asynchronously as  **
** subtasks of WYLBUR.  currently, the functions          **
** operating under the subtask are the os I/O functions   **
** such as obtain, locate, rdjfcb, open, close, etc.      **
**                                                        **
************************************************************
         SPACE 2
         DIOWAHDR
*
STECB    DC    F'0'                Ecb for DISK subtask
OSR13    DS    F                   addr of os save area for subtask
WACPR    DS    A                   Saved CP ptr
WAR14    DS    10F                 reg 14-7 subtask reg save area
WAR15    EQU   WAR14+4,4,C'F'
WASA     DS    18F                 r13 save area during subtask
*
UCB      DC    A(0)                ucb addr for spec volume
VOLENTRY DC    A(0)                address of volume table entry
AVAIL    DC    X'00'               avail flag - 00=avail, ff=busy
IDMASK   DC    C'1'                mask for identity
*
DFL      DC    X'00'               flags
DFREPL   EQU   X'08'               - stow repl to be done at close
DFNOACTG EQU   X'04'               - mounted volume is not accounted
DFUPTSPC EQU   X'02'               - update space acctg at close
DFUSPCNM EQU   X'01'               - no cond show space call if on
*
FLAGS    DS    CL5                 save dsname flags
F1       EQU   FLAGS,1,C'X'        first dsname flag
F2       EQU   FLAGS+1,1,C'X'      second dsname flag
F3       EQU   FLAGS+2,1,C'X'      third dsname flag
F4       EQU   FLAGS+3,1,C'X'      fourth dsname flag
F5       EQU   FLAGS+4,1,C'X'      fifth dsname flag
*
DSDD     DC    CL8'IOVVVVVV'       ddname
*
WAVFLG1  DC    X'00'               vflg1 from volume entry
WAVFLG2  DC    X'00'               vflg2 from volume entry
*
DSTYPE   DC    C'IO'               type of volume (IO/DD/TM)
*
         DC    H'0'                reserved
*
WAABEND  DC    A(0)                abend routine addr
*
WAUSER   DC    CL3' '              signed on user
WAGRP    DC    CL2' '              signed on group
WASGRP   DC    CL3' '              subgroup   ** temp **
         SPACE 2
**  exlst for dcb
EXLST    DS    0F
         DC    X'00'               entry to be filled in
         DC    AL3(0)
         DC    X'87'               last entry/jfcb pointer
         DC    AL3(JFCB)
         SPACE 2
**  iob for excp
IOB      DS    0D
         DC    XL2'C200'
IOBSNS   DC    H'0'
IOBECB   DC    A(0)                ecb address
IOBCSW   DC    2F'0'
IOBUNIT  EQU   IOBCSW+4
IOBCHNL  EQU   IOBCSW+5
IOBLEFT  EQU   IOBCSW+6,2
IOBSTART DC    F'0'
IOBDCB   DC    A(0)                dcb address
         DC    2F'0'
         DC    XL1'0'
IOBB     DC    XL2'0'
SEEK     DC    XL5'0'
         EJECT
**  channel program info...
MT       EQU   X'80'               multi-track
SCHIDEQ  EQU   X'31'               search id equal
TIC      EQU   X'08'               xfer in channel
SCHKYEQ  EQU   X'29'               search key equal
SCHKYHI  EQU   X'49'               search key high
SCHKYHE  EQU   X'69'               search key hi or equal
SCHKADEQ EQU   X'2D'               search key and data equal
SCHKADHI EQU   X'4D'               search key and data high
SCHKADHE EQU   X'6D'               search key and data hi or equal
SWKADKY  EQU   SCHKADHE-SCHKYHE    used to swap sch kad/sch key
RDCNT    EQU   X'12'               read count
RDDATA   EQU   X'06'               read data
RDKYDATA EQU   X'0E'               read key and data
NOPIC    EQU   X'03'               nop in channel
*
CC       EQU   X'40'               command chain
DC       EQU   X'80'               data chain
SLI      EQU   X'20'               sli
SKP      EQU   X'10'               skip data xfer
         SPACE 2
SRCHCCW  CCWP  SCHIDEQ,SEEK,CC+SLI,5        search for prev rec
         CCWP  TIC,SRCHCCW,CC+SLI,0
CCWSW    CCWP  TIC,ID,CC+SLI,0              id/pdsread
ID       CCWP  SCHIDEQ+MT,ENDTEST,CC+SLI,5  is it last vtoc rec?
         CCWP  TIC,KEY,CC+SLI,0             tic if no
         CCWP  TIC,ENDCCW1,CC+SLI,0         tic if yes
*
**  length field is changed in following channel command...
KEY      CCWP  SCHKADEQ+MT,DSNAME,CC+SLI,0  is rec one we want?
         CCWP  TIC,ID,CC+SLI,0              tic if no
         CCWP  RDCNT+MT,SRCHC,SLI,5         read addr of foll rec
*
**  length field is changed in following channel command...
ENDCCW1  CCWP  SCHKADEQ,DSNAME,CC+SLI,0     is last vtoc rec we want?
         CCWP  TIC,ENDCCW,CC+SLI,0          tic if no
         CCWP  NOPIC,SEEK,CC+SLI+SKP,1      dummy cmnd
ENDCCW2  CCWP  SCHIDEQ,ENDTEST,CC+SLI,5     so we can search again
         CCWP  TIC,ENDCCW2,CC+SLI,0
READCCW2 CCWP  RDKYDATA,DS1DSNAM,SLI,DS1END-DS1DSNAM  read dscb
**
ENDCCW   CCWP  NOPIC,SEEK,SLI,1      dummy cmd to flag end of search
** if final csw points here then the vtoc has been completely searched
*
**  channel program restarted here if a record found we want
READCCW  CCWP  SCHIDEQ,SRCHC,CC+SLI,5     search for the one we wanted
         CCWP  TIC,READCCW,CC+SLI,0
         CCWP  RDKYDATA,DS1DSNAM,SLI,DS1END-DS1DSNAM  read dscb
*
**  channel program section for reading pds directory
PDSREAD  CCWP  RDCNT+MT,SRCHC,CC+SLI,5
         CCWP  RDKYDATA,DBUF,SLI,264
         EJECT
**  misc work areas and constants
CCREDT   DS    D
DSNAME   DC    CL44' '             blank dsname for initial
DSN      DC    44X'04'
NEWDSNAM DC    CL44' '
*
BLDL     DS    0F
         DC    H'1'                one entry
         DC    AL2(BLDLSZ)         length of entry
MEMBER   DS    CL8                 member name
BLDLTTR  DS    CL3                 member ttr
*  stow requires C but not K and Z...
STOWLEN  DS    X                   C flags; user data length
STOWDATA DS    XL62                user data info
STOWSZ   EQU   *-MEMBER
         ORG   STOWLEN             BLDL info returned:
         DS    XL2                 K and Z flags
BLDLLEN  DS    X                   C flags; user data length
BLDLDATA DS    XL62                user data info
BLDLSZ   EQU   *-MEMBER
*
RRECFM   DS    CL1                 recfm
*
SCRVLST  DS    0F                  scratch list and others
         DC    H'1'                number of volumes
DEVCODE  DS    CL4                 result of devtype
DSVID    DS    CL6                 volume id
         DC    X'0'                byte of zero
SCRRET   DC    X'0'                return code from scratch
         SPACE 2
VTOCCCW  DC    AL3(ID)             tic addr for show dsnames
PDSCCW   DC    AL3(PDSREAD)        tic addr for show directory
LASTCCW  DC    AL3(ENDCCW+8)  addr in csw when vtoc search done
LASTCCW1 DC    AL3(ENDCCW)    addr in csw when last vtoc rec wanted
RECSIZE  DS    F
LRECSIZE DS    F
ERROR    DS    F
ERRBYTE  EQU   ERROR+3,1,C'X'
SPACE    DS    F
DEVBLOCK DS    F                   device block size
RETCOD   DS    F
         EJECT
***  decbs and paramter lists...
         READ  DECB,SF,DCB,DBUF,MF=L
         SPACE 2
DSCB     CAMLST SEARCH,DSNAME,DSVID,DS1FMTID
         SPACE 2
SCRUAL   DS    A                   scratch ual ptr (scip security sys)
SCRLST   CAMLST SCRATCH,DSNAME,,SCRVLST,,OVRD
         SPACE 2
USCATL   CAMLST NAME,DSNAME,0,CATBLOCK
         SPACE 2
USCATL2  CAMLST BLOCK,CATNTTR,CATVOLID,CATBLOCK
CAMFCVOL EQU   X'80'               flag bit for cvol/no cvol use
         SPACE 2
VTOC     CAMLST SEARCH,DSN,DSVID,VTOCAREA
         SPACE 2
VTOC3    CAMLST SEEK,DS1PTRDS,DSVID,IECSDSL3
         SPACE 2
CATLST   CAMLST CAT,DSNAME,0,SCRVLST  cat/uncat/recat
         SPACE 2
RENAMLST CAMLST RENAME,DSNAME,NEWDSNAM,SCRVLST
         SPACE 2
OPENLIST OPEN  (DCB),MF=L
         SPACE 2
         DS    3A                  enq control block pfx (mvs only)
ENQVOL   ENQ   (0,DSVID,E,6,STEP),MF=L
         SPACE 2
         DS    3A                  enq control block pfx (mvs only)
ENQDSN   ENQ   (0,0,E,0,SYSTEM),RET=USE,MF=L
         SPACE 2
         DS    2A                  Reserved
*
*
IOWALOC  DC    A(0)                GETMAIN buffer addr
IOWALEN  DS    F'0'                GETMAIN buffer len
*
ACSPARM  DS    0F                  access svc parm list
ACSPFLGS DC    A(ACWOPER)          ptr to flag bytes
ACSPDSN  DC    A(DSNAME)           ptr to dsname
ACSPDSCB DC    A(DS1FMTID)         ptr to f1 dscb
ACSPACCT DC    A(UALAUTH)          ptr to acct (uuuggssia)
ACWOPER  DS    X                   acs flag bytes:  operation
ACWMODE  DS    X                                    mode
         SPACE 2
ACSUAL   DS    0F                  start on fullword
UALLEN   DC    H'20'               total ual length
UALAUTH  DC    CL5' '              signed on user
UALSUBGR DC    CL2' '              signed on subgroup
UALKIAF  DC    XL2'0000'           kifl & kafl flags
UALKEY   DC    XL5'0'              accessor authority
UALODSCB DC    A(0)                0 or old dscb pointer
         SPACE 2
PARMLIST DS    0F
         COPY  ALLOPARM
         EJECT
**  dummy dcb to allocate space for dcb to be moved in
DCB      DCB   DSORG=PS,MACRF=(RP,WP)
         EJECT
FOURS    DCB   DSORG=PS,MACRF=E,EXLST=EXLST
         EJECT
***** data buffer/work areas *****
         SPACE 2
LBUF     DS    0F                  local work buffer
KWR      KWR
         SPACE 2
         AIF   (&BUFRMAX GT 6000).BUFOK
   MNOTE 8,'&&BUFRMAX=&BUFRMAX -- looks suspicious; check SYSDEFN.'
         MEXIT
.BUFOK   ANOP
DBUF     DS    0D
         DS    (&BUFRMAX)C         Famous I/O buffer
         SPACE 2
*** work area for dvtoc
**  first part is format 4 dscb area
*
         ORG   DBUF
VTOCAREA DS    0D
         IECSDSL1 4
         ORG   DS4VTOCE            fmt 4 extent description
         DS    CL2
VTOCBEG  DS    CL4
VTOCEND  DS    CL4
         DS    279C
**
PAGEGET  DS    F
VTOCSV   DS    11F
*
ENDTEST  DS    XL5
*
DVTAREA  DVTAREA ,                 define devcode area
*
NUMTRK   DS    H
*
SRCHC    DS    H
SRCHH    DS    H
SRCHR    DS    H
         SPACE 2
JFCB     DS    0D
         IEFJFCBN
         SPACE 2
**  volume catalog entry work area...
CATBLOCK DS    0D
CATNOENT DS    H
CATDVTYP DS    CL4
CATVOL   DS    CL6
CATSEQNO DS    CL2
CATENTSZ EQU   *-CATDVTYP
*
CATNTTR  EQU   CATBLOCK+256        ttr of block foll read block
CATVOLID EQU   CATNTTR+3           vol id of catlg
CATRSIZE EQU   CATVOLID+6-CATBLOCK size read from catlg
         SPACE 2
***  format 1 dscb work area ***
         DS    0D
         IECSDSL1 1
* iecsdsl1 now defines the label ds1end
DS1SIZE  EQU   DS1END-DS1FMTID     size of non dsname dscb
DS1SPACE EQU   DS1SYSCD-1          location of space accounting flag
SPACFLAG EQU   X'01'               space accounting flag bit
*
TRKADDS1 DS    XL5                 cchhr of dscb returned by obtain
         SPACE 2
**  format 3 dscb work area...
         ORG   IECSDSL1
         DS    0D
         IECSDSL1 3
* iecsdsl1 now defines the label ds3end
         SPACE 2
**  format 5 dscb work area...
         ORG   IECSDSL1
         IECSDSL1 5
         SPACE 2
         ORG   CATBLOCK+CATRSIZE   (must be .gt. ds3end)
*
         DS    0F
SAREA    DS    XL512               room for SBUF and SCATBUF
*
         DS    0F
JFCBSAVE DS    CL(JFCBLGTH)
         SPACE 2
* the following field is used only for a save..replace command
* it saves the old dscb so that open can recreate the protection
* fields in the dscb when the new dataset is opened.  actually
* this field need only be used when an actual scratch of the
* dataset must be done because of a change in size
*
DSCBSAVE DS    0D                  save the fmt1 dscb
         DS    XL(DS1SIZE)
         EJECT ,
*-
*- Define RACF parameter lists
*-
         SPACE ,
RACFID   DC    XL1'00',CL6'GG$UUU'     RACF USER ID
RACFPSWD DC    XL1'00',CL8'PASSWORD'   RACF PASSWORD
RACFPDAT DC    XL3'87300F'             RACF PASSWORD CHANGE DATE
GREMLIN  DC    AL1(0)              Length byte for profile delete
*                                  Sorry, every pgm should have one
GREMPRF  DC    CL44' '             Profile name to delete
         SPACE ,
*GEN
RACINIT  RACINIT USERID=RACFID,PASSWRD=RACFPSWD,                       X
               ENVIR=CREATE,ACEE=*-*,MF=L
RACINITL EQU   *-RACINIT           GENERATE LENGTH OF RACINIT
         ORG   RACINIT             ORIGIN BACK
RACHECK  RACHECK MF=L
         SPACE ,
         ORG   RACINIT             ORIGIN BACK
ICHELST  ICHEINTY ALTER,TYPE='USR',ENTRY=RACFID,                       X
               ACTIONS=(ICHSETP,ICHSETPD),MF=L
         SPACE ,
ICHSETP  ICHEACTN FIELD=PASSWORD,FLDATA=(8,RACFPSWD),MF=L
         SPACE ,
ICHSETPD ICHEACTN FIELD=PASSDATE,FLDATA=(3,RACFPDAT),MF=L
ICHCLR   EQU   ICHELST,*-ICHELST,C'C'       PARAMETER LIST LENGTHS
         ORG   RACINIT
ICHEDEL  ICHEINTY DELETE,TYPE='DS',ENTRY=*-*,GENERIC=UNCOND,MF=L
*NOGEN
*POP
         ORG
         MEND
